// BitmapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Bitmap.h"
#include "BitmapDlg.h"
#include <wingdi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapDlg dialog

CBitmapDlg::CBitmapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBitmapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBitmapDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBitmapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBitmapDlg)
	DDX_Control(pDX, IDC_PICTURE, m_picture);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBitmapDlg, CDialog)
	//{{AFX_MSG_MAP(CBitmapDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_GRAYSCALE, OnButtonGrayscale)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapDlg message handlers

BOOL CBitmapDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBitmapDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBitmapDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBitmapDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CBitmapDlg::LoadImageData(CString bmpPath)
{
	m_strBmpPath = bmpPath;
	
	if(m_hBmp!=NULL){
		m_hBmp = NULL;
	}
	if(m_hDibFile!=NULL){
		m_hDibFile = NULL;
	}

	m_hDibFile = CreateFile(m_strBmpPath,GENERIC_READ,
							   FILE_SHARE_READ,NULL,OPEN_EXISTING,
							   FILE_ATTRIBUTE_READONLY,NULL);
	
	DWORD nRead=0;

	BYTE* pcBmpFH = (BYTE *)calloc(sizeof(BITMAPFILEHEADER),1);

	if(! ReadFile(m_hDibFile,pcBmpFH,
		sizeof(BITMAPFILEHEADER),&nRead,NULL) || (nRead!=sizeof(BITMAPFILEHEADER)) ) 
	{
		AfxMessageBox("Nu am putut incarca in structura !");
		return FALSE;
	}

	m_bmpFH = (BITMAPFILEHEADER*)pcBmpFH;

	nRead=0;

	BYTE* pcBmp = (BYTE*)calloc(m_bmpFH->bfSize - sizeof(BITMAPFILEHEADER),1);

	if(! ReadFile(m_hDibFile,(void*)pcBmp,m_bmpFH->bfSize - sizeof(BITMAPFILEHEADER),
		&nRead,NULL) || (nRead!=m_bmpFH->bfSize - sizeof(BITMAPFILEHEADER)) ) 
	{
		AfxMessageBox("Nu am putut incarca in structura !");
		return FALSE;
	}
	nRead = 0;
	m_bmpIH = (BITMAPINFOHEADER *)pcBmp;
	m_bmpI = (BITMAPINFO*)pcBmp;
	int nColors = NULL;
	if (m_bmpIH->biBitCount < 16)
	{
		nColors = 1 << m_bmpIH->biBitCount;
	}
	
	CloseHandle(m_hDibFile);

	m_bmpWidthBytes = m_bmpIH->biWidth * m_bmpIH->biBitCount/8;
	while(m_bmpWidthBytes%4 != 0){
		m_bmpWidthBytes++;
	}

	//int nrBytes = m_bmpFH->bfSize - sizeof(BITMAPFILEHEADER) - sizeof(BITMAPINFOHEADER) - (nColors * sizeof(RGBQUAD));
	//bits = new BYTE[nrBytes];
	//bits = (unsigned char *)text;
	
	//memcpy(bits,pcBmp,nrBytes);
	return TRUE;
}

void CBitmapDlg::SaveFile(CString szFilename,BYTE* imageBuff)
{
	
	HANDLE hDibFile = CreateFile(szFilename,GENERIC_WRITE,
							   FILE_SHARE_READ,NULL,CREATE_ALWAYS,
							   FILE_ATTRIBUTE_NORMAL,NULL);
	if(hDibFile==INVALID_HANDLE_VALUE)
	{
		szFilename = "Error creating bmp file: "+szFilename;
		MessageBox(szFilename,"Error",MB_OK );
		return;
	}

	DWORD nWrite=0;
	if(! WriteFile(hDibFile,(void*)m_bmpFH,
		sizeof(BITMAPFILEHEADER),&nWrite,NULL) || (nWrite!=sizeof(BITMAPFILEHEADER)) ) 
	{
		szFilename = "Error writing bmp file: "+szFilename;
		MessageBox(szFilename,"Error",MB_OK );
		return;
	}

	if(imageBuff!=NULL){
		DWORD nWrite=0;
		if(! WriteFile(hDibFile,(void*)m_bmpIH,
			sizeof(BITMAPINFOHEADER),&nWrite,NULL) || (nWrite!=sizeof(BITMAPINFOHEADER)) ) 
		{
			szFilename = "Error writing bmp file: "+szFilename;
			MessageBox(szFilename,"Error",MB_OK );
			return;
		}
		WriteFile(hDibFile,(void*)imageBuff,m_bmpFH->bfSize-m_bmpFH->bfOffBits,&nWrite,NULL);
	}
	else{
		WriteFile(hDibFile,(void*)m_bmpI,m_bmpFH->bfSize-sizeof(BITMAPFILEHEADER),&nWrite,NULL);
	}
	CloseHandle(hDibFile);
}

COLORREF CBitmapDlg::GetPixel(int row, int col)
{
	BYTE* buffAdress = (BYTE*)m_bmpI + sizeof(BITMAPINFOHEADER) + row * m_bmpWidthBytes + col*3;
	return RGB(*(buffAdress+2),	*(buffAdress+1),*(buffAdress));
}

void CBitmapDlg::SetPixel(int row, int col, COLORREF color)
{
	BYTE* buffAdress = (BYTE*)m_bmpI + sizeof(BITMAPINFOHEADER) + row * m_bmpWidthBytes + col*3;

	*(buffAdress)   = GetBValue(color);
	*(buffAdress+1) = GetGValue(color);
	*(buffAdress+2) = GetRValue(color);
}

COLORREF CBitmapDlg::GetPixel(BYTE *imageBuff, int row, int col)
{
	BYTE* buffAdress = imageBuff + row * m_bmpWidthBytes + col*3;
	return RGB(*(buffAdress+2),	*(buffAdress+1),*(buffAdress));
}

void CBitmapDlg::SetPixel(BYTE *imageBuff, int row, int col, COLORREF color)
{
	BYTE* buffAdress = imageBuff + row * m_bmpWidthBytes + col*3;

	*(buffAdress)   = GetBValue(color);
	*(buffAdress+1) = GetGValue(color);
	*(buffAdress+2) = GetRValue(color);

}

CString CBitmapDlg::GetFileName(CString strBmpPath)
{
	if(strBmpPath.IsEmpty())
		return "";
	int pos = strBmpPath.ReverseFind('\\');
	CString strFile;
	strFile = strBmpPath.Mid(pos+1,strBmpPath.GetLength()-pos);
	return strFile;
}

void CBitmapDlg::ClearBitmapInfo()
{
	if(m_bmpFH!=NULL)
		delete m_bmpFH;
	m_bmpFH = NULL;

	if(m_bmpI!=NULL)
		delete m_bmpI;
	m_bmpI = NULL;


	m_bmpIH = NULL;

}


void CBitmapDlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here
	char szFilter[] = "Bitmap Files (*.bmp)|*.bmp||";//All Files (*.*)|*.*||";
	CFileDialog MyDialog( true, NULL, "images\\*.bmp",
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT  ,szFilter,NULL);
	if( MyDialog.DoModal() == IDCANCEL )
		return;
	else{
	  m_strBmpPath = MyDialog.GetPathName();
	}
	delete MyDialog;


//----------------------------------------------------------------
	//ClearBitmapInfo();
	LoadImageData(m_strBmpPath);
	DisplayImage(m_bmpIH->biWidth/2, m_bmpIH->biHeight/2,m_strBmpPath);


	//SaveFile(OUT_DIR + GetFileName(m_strBmpPath));
//----------------------------------------------------------------

	//CloseHandle(m_hBmp);	
}

void CBitmapDlg::DisplayImage(int width, int heigth, CString path)
{
	m_hBmp = (HBITMAP)LoadImage(AfxGetApp()->m_hInstance, path, 
		IMAGE_BITMAP,
		width,//LR_DEFAULTSIZE,
		heigth,//LR_DEFAULTSIZE,
		LR_LOADFROMFILE);

	m_picture.SetBitmap(m_hBmp);
}



void CBitmapDlg::OnButtonGrayscale() 
{
	// TODO: Add your control notification handler code here
	if(m_strBmpPath.GetLength()==0)
	{
		AfxMessageBox("Please insert an image !!");
		return;
	}

	int color;
	BYTE b;
	
	for(int row=0;row<m_bmpIH->biHeight;row++)
	{
		for(int col=0;col<m_bmpIH->biWidth;col++)
		{
			color = GetPixel(row,col);
			b = (BYTE)(0.299*GetRValue(color)) + (BYTE)(0.587*GetGValue(color)) + (BYTE)(0.114*GetBValue(color));
			SetPixel(row, col, RGB(b,b,b));
		}
	}

	SaveFile("..\\temp.bmp");

	DisplayImage(m_bmpIH->biWidth/2, m_bmpIH->biHeight/2, "..\\temp.bmp");	
}
